`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: Quenne Electric	
// Engineer: Andras Bognar
// 
// Create Date:    12:11:28 05/09/2007 
// Design Name: 
// Module Name:    futofeny 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module futofeny(REC, SEND, DIR1, EN1, Q1, CLK);
    input REC;
	 input CLK;
    output SEND;
    output DIR1;
    output EN1;
    output [7:0] Q1;

	 reg[19:0]prescale = 0;
	 reg [7:0] ledek = 8'h01;
	 reg line1;

		always@(posedge CLK)							//prescaler
		begin
			if(REC)prescale <= prescale + 1;
			if (prescale==20'hFFFFF)line1=1;
			else line1=0;
		end

		always @(posedge line1)						//shift register
		begin
			ledek <= ledek << 1;
			ledek[0] <= ledek[7];
		end

		assign Q1 = ledek;  
		assign SEND=ledek[0];
		assign DIR1=1;
		assign EN1=0;

endmodule
